<?php
ini_set('display_errors', 'On');
error_reporting(E_ALL | E_STRICT);
/*'
'********************************************************
' My first web calculator
'
' Author     : Elario Belmontes, Jr.
' Description: Four function calculator simulator for
'              educational purposes to illustrate the 
'              use of a web page on a personal web
'              server
' Languanges : PHP, JAVASCRIPT, JQUERY, HTML, CSS
' File Name  : calc_42.php
' Disclaimer: This software is intended for educational learning
'             purposes.
'
'             This software is provided "AS IS" and without any
'             expressed or implied warranties, including, without
'             limitation, the implied warranties of merchantability
'             and fitness for a particular purpose.
'
'             No guarantee; No warranty; Install / Use at your own risk.
'
'
' Copyright (C) 2015 Larry Belmontes, Jr. 
'
'
'
'********************************************************
'
/*'
'********************************************************
' Create/Resume a session
'********************************************************
'*/
session_start();
/*'
'********************************************************
' Get my script file name
'********************************************************
'*/
$myScriptName = basename($_SERVER['PHP_SELF']);
/*'
'********************************************************
' Initialize variables
'********************************************************
'*/
$myTitle = "myWeb Calculator";
$ErrMsg = "&nbsp;";
$MaxInput = 12;
/*'
'********************************************************
' Process FORM post (i.e. calculator button pressed)
'********************************************************
'*/
if ($_SERVER['REQUEST_METHOD'] === 'POST')
	{
	//echo "session NumberIn=" . $_SESSION['NumberIn'] . "<br>";
	//echo "session NumberInFunction=" . $_SESSION['NumberInFunction'] . "<br>";
	/*'
	'********************************************************
	' Obtain data from FORM controls 
	'   and initialize variables
	'********************************************************/
	$frm_AuditTape = ($_POST['AuditTape']);
	$frm_NumIn = ($_POST['NumIn']);
	$frm_AccumTape = ($_POST['AccumTape']);
	/*'
	'********************************************************
	' Button on FORM pressed -
	'   Process number, function or housekeep button on form
	'
	'   Loop through each FORM field and take appropriate
	'     action from POST data
	'       (i.e.  AuditTape=&AccumTape=&NumIn=&B8=8)
	'********************************************************/
	foreach($_POST as $frm_Control =>$value)
		{
		switch ($frm_Control)
			{
			/*'
			'********************************************************
			' Math functions: add, subtract, multiply, divide
			'********************************************************/
			case "Fplus":
			case "Fminus":
			case "Fmult":
			case "Fdiv":
				Do_Math();
			break;
			/*'
			'********************************************************
			' Terminate Math function: equals
			'********************************************************/
			case "Fequal":
				Finalize_Math();
			break;
			/*'
			'********************************************************
			' Housekeep: Clear all
			'********************************************************/
			case "Fclear":
				Clear_key();
			break;
			/*'
			'********************************************************
			' Housekeep: Power Off
			'********************************************************/
			case "Poff":
				Power_Off_key();
   				exit();
			break;			
			/*'
			'********************************************************
			' Housekeep: Power On
			'********************************************************/
			case "Pon":
   				Power_On_key();
			break;
   			/*'
			'********************************************************
			' Housekeep: Clear entry
			'********************************************************/
			case "Fcleare":
				Clear_Entry_key();
			break;
			/*'
			'********************************************************
			' Numeric entry
	   		'  Limit to 16 digits entry excluding decimal point
			'********************************************************/
   			case "B0":
			case "B1":
			case "B2":
			case "B3":
			case "B4":
			case "B5":
			case "B6":
			case "B7":
			case "B8":
			case "B9":
		    	Numeric_key();
			break;
			/*'
			'********************************************************
			' Decimal point entry
			'********************************************************/
   			case "Bdot":
   				Decimal_key();
			break;
			}
		}
	}
else
	{
	/*'
	'********************************************************
	' NOT a POST, initialize session variables 
	'  Assume first time invoked
	'********************************************************/
    $_SESSION['NumberIn'] = "";
    $_SESSION['NumberInFunction'] = "";
	$frm_AuditTape = "";
	$frm_NumIn = "";
	$frm_AccumTape = "";
   	$myTitle = "Welcome to myWeb Calculator and happy calculating!";
	}
	
/*'
'********************************************************
' Functions Section
'********************************************************
'*/
/*'
'********************************************************
' Subroutine: Do_Math
' Math functions: add, subtract, multiply, divide
'********************************************************/
function Do_Math()
	{
   	global $frm_NumIn, $frm_AccumTape, $frm_AuditTape, $frm_Control, $ErrMsg;
	if ($frm_NumIn > "")
		{
		$frm_AccumTape = $frm_AccumTape . $_SESSION['NumberIn'] . $_SESSION['NumberInFunction'];
    	ComputeIT();
		$frm_AuditTape = $frm_AuditTape . $frm_NumIn . " " . $_POST[$frm_Control] . " " . chr(13) . chr(10);
		$frm_AccumTape = $frm_AccumTape . $frm_NumIn . "=" . $_SESSION['NumberIn'] . " " . chr(13) . chr(10);
		$_SESSION['NumberInFunction'] = $_POST[$frm_Control];
		$frm_NumIn = "";
		}
	else
		{
		$ErrMsg = "No data entered...";
		}
	}
/*'
'********************************************************
' Subroutine: Finalize_Math
' Terminate Math function: equals key
'********************************************************/
function Finalize_Math()
	{
   	global $frm_NumIn, $frm_AccumTape, $frm_AuditTape, $frm_Control, $ErrMsg;
   	If ($frm_NumIn > "")
		{
   		$frm_AccumTape = $frm_AccumTape . $_SESSION['NumberIn'] . $_SESSION['NumberInFunction'];
    	ComputeIT();
		$frm_AuditTape = $frm_AuditTape . $frm_NumIn . " " . $_POST[$frm_Control] . " " . chr(13) . chr(10);
		$frm_AuditTape = $frm_AuditTape . $_SESSION['NumberIn'] . " T " . chr(13) . chr(10);
		$frm_AccumTape = $frm_AccumTape . $frm_NumIn . "=" . $_SESSION['NumberIn'] . " " . chr(13) . chr(10);
		$frm_AccumTape = $frm_AccumTape . "^^^^^^^^^^^^^^^^^^^^^^^ " . chr(13) . chr(10);
		$frm_NumIn = "";
		$_SESSION['NumberIn'] = "";
		$_SESSION['NumberInFunction'] = "";
		}
	else
		{
		$ErrMsg = "No data entered...";
		}
	}
/*'
'********************************************************
' Subroutine: Clear_key
' Housekeep: ClearAll key
'********************************************************/
function Clear_key()
	{
	global $frm_AuditTape, $frm_AccumTape, $frm_NumIn;
	$frm_AuditTape = "";
	$frm_AccumTape = "";
	$frm_NumIn = "";
	$_SESSION['NumberIn'] = "";
	$_SESSION['NumberInFunction'] = "";
	}
/*'
'********************************************************
' Subroutine: Power_Off_key
' Housekeep: Power Off key
'********************************************************/
function Power_Off_key()
	{
	global $myScriptName;
	unset($_SESSION['NumberIn']);
	unset($_SESSION['NumberInFunction']);
	ob_end_clean();
	echo "Powered Off!<br><br>Click " .
	 "<a title=" . chr(34) . "Power On Calculator" . chr(34) .
	 " href=" . chr(34) . $myScriptName . Chr(34) . "><font color=" . chr(34) . "#FFFFFF" .
	 "><span style=" . chr(34) . "background-color: #0000CC" . chr(34) .
	 ">here</span></font></a>" . " to power on myWeb Calculator...";
	}
/*'
'********************************************************
' Subroutine: Power_On_key
' Housekeep: Power On
'********************************************************/
function Power_On_key()
	{
	global $ErrMsg;
	$ErrMsg = "Power already ON...";
	}	
/*'
'********************************************************
' Subroutine: Clear_Entry_key
' Housekeep: Clear entry 
'********************************************************/
function Clear_Entry_key()
	{
	global $frm_NumIn;
	$frm_NumIn = "";
	}
/*'
'********************************************************
' Subroutine: Numeric_key
' Numeric entry
'  Limit to n digits entry based on MaxInput excluding decimal point
'********************************************************/
function Numeric_key()
	{
   	global $frm_NumIn, $MaxInput, $ErrMsg, $frm_Control;
	if (substr_count($frm_NumIn , ".") == 0) 
		{
   	    //' no decimal found in number input
   	    //' check for MAXInput - 1
   		if (strlen($frm_NumIn) > ($MaxInput - 1))
			{
   			$ErrMsg = "Input limited to " . $MaxInput . " digits!";
			}
		Else
    		{
			$frm_NumIn = $frm_NumIn . $_POST[$frm_Control];
			}
	}		
   	Else
	{
   		//' found decimal point in number input
   		//'  check for MAXInput
		if (strlen($frm_NumIn) > $MaxInput)
			{
			$ErrMsg = "Input limited to " . $MaxInput . " digits!";
			}
		Else
			{
    		$frm_NumIn = $frm_NumIn . $_POST[$frm_Control];
			}
   	}	
	}
/*'
'********************************************************
' Subroutine: Decimal_key
' Decimal point entry
'********************************************************/
function Decimal_key()
	{
	global $frm_NumIn;
	if (substr_count($frm_NumIn,".") == 0)
		{
		$frm_NumIn = $frm_NumIn . ".";
		}
	}
/*'
'********************************************************
' Subroutine: ComputeIT
' Compute last result with current numeric entry
'   based on math function
'********************************************************/
function ComputeIT()
	{
	global $frm_NumIn;
	switch ($_SESSION['NumberInFunction'])
		{
		case "":
	   		$_SESSION['NumberIn'] = floatval($frm_NumIn);
		break;
		case "+":
   			$_SESSION['NumberIn'] = $_SESSION['NumberIn'] + floatval($frm_NumIn);
		break;
		case "-":
   			$_SESSION['NumberIn'] = $_SESSION['NumberIn'] - floatval($frm_NumIn);
		break;
		case "x":
   			$_SESSION['NumberIn'] = $_SESSION['NumberIn'] * floatval($frm_NumIn);
		break;
		case "/":
   			$_SESSION['NumberIn'] = $_SESSION['NumberIn'] / floatval($frm_NumIn);
		break;
		}	
	}

?>


<html>

<head>

<style>
#t1 {color:green; font-size: 8pt; text-align: right;}
#t2 {color:red; font-size: 8pt; text-align: right;}
#btn {width:32; height:32;}
</style>

<title>myCalc</title>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<!--
<script type="text/javascript" src="Sys_web/Incl/jquery-latest.js">
</script>
-->
<!-- Script to scroll both result windows simultanously -->
<script type="text/javascript">
        $(function() {
            $('#t1').scroll(function() {
            $('#t2')
                .scrollTop($('#t1').scrollTop());
            });
			$('#t2').scroll(function() {
            $('#t1')
                .scrollTop($('#t2').scrollTop());
            });
        });
    </script>
    
</head>

<body>

<!-- Calculator FORM -->
<form method="POST" action="<?php echo $myScriptName; ?>" name="CalculateIT">
<!-- Place border on FORM and border title accordingly -->
<fieldset style="border-color:green; background-color:beige">
<legend style="color:blue; font-size: 18pt; background-color:lightsteelblue"><?php echo $myTitle; ?></legend>
<!-- Audit Trail and Intermediate Result textboxes -->
<table align="center">
<tr>
<td align="center">Audit Trail</td>
<td align="center">Intermediate Results</td>
</tr>
<tr>
<td><textarea id="t1" rows="15" name="AuditTape" cols="30"  readonly="readonly"><?php echo $frm_AuditTape; ?></textarea></td>
<td><textarea id="t2" rows="15" name="AccumTape" cols="50" readonly="readonly"><?php echo $frm_AccumTape; ?></textarea></td>
</tr>
</table>

<!-- Script to scroll both result windows to bottom of window simultaneously -->
<script type="text/javascript">
function Scroll_to_Bottom() 
{
document.getElementById('t1').scrollTop=document.getElementById('t1').scrollHeight;
document.getElementById('t2').scrollTop=document.getElementById('t2').scrollHeight;
}
// Call the function
Scroll_to_Bottom ();
    </script>

<!-- Audit Trail and Intermediate Result textboxes -->
<br/> 
<table border="1" cellpadding="10" cellspacing="0" align="center" style="border-collapse: collapse ; background-color:DarkSeaGreen">
<tr>
<td>
<!-- Place border on keyboard and display components -->
<fieldset style="border-color:green; background-color:lightsteelblue">
<!-- Calculator Display Title -->
<?php echo $MaxInput; ?> Digit Display
<br/>
<!-- Calculator Display -->
	<input name="NumIn" size="15" value="<?php echo $frm_NumIn; ?>" style="text-align:right; font-size: 10pt" readonly="readonly">
<!-- Calculator Error Message area -->
<br/>
<font color=red size="2"><?php echo $ErrMsg; ?></font>
<!-- Calculator Keypad -->
<br/>
      <input id="btn" type="submit" value="C"   name="Fclear" >&nbsp;
      <input id="btn" type="submit" value="CE"  name="Fcleare" >&nbsp;
      <input id="btn" type="submit" value="off" name="Poff" style="background-color: red; ">&nbsp;
      <input id="btn" type="submit" value="on"  name="Pon" style="background-color: green; color:lawngreen; ">&nbsp;
<br/>
      <input id="btn" type="submit" value="7"   name="B7" >&nbsp;
      <input id="btn" type="submit" value="8"   name="B8" >&nbsp;
      <input id="btn" type="submit" value="9"   name="B9" >&nbsp;
      <input id="btn" type="submit" value="/"   name="Fdiv" >&nbsp;
<br/>
      <input id="btn" type="submit" value="4"   name="B4" >&nbsp;
      <input id="btn" type="submit" value="5"   name="B5" >&nbsp;
      <input id="btn" type="submit" value="6"   name="B6" >&nbsp;
      <input id="btn" type="submit" value="x"   name="Fmult" >&nbsp;
<br/>
      <input id="btn" type="submit" value="1"   name="B1" >&nbsp;
      <input id="btn" type="submit" value="2"   name="B2" >&nbsp;
      <input id="btn" type="submit" value="3"   name="B3" >&nbsp;
      <input id="btn" type="submit" value="-"   name="Fminus" >&nbsp;
<br/>
      <input id="btn" type="submit" value="0"   name="B0" >&nbsp;
      <input id="btn" type="submit" value="."   name="Bdot" >&nbsp;
      <input id="btn" type="submit" value="="   name="Fequal" >&nbsp;
      <input id="btn" type="submit" value="+"   name="Fplus" >&nbsp;
</fieldset>
</td>
</tr>
</table>
</fieldset>
</form>
<u><i>myCalc</i></u> is for illustrative and educational purposes and does not represent a fully robust and tested calculator product.<br>
Copyright &copy; 2015  Larry Belmontes, Jr.
</body>

</html>